#pragma once

#include "UIListCommonDefine.hpp"
#include <list>

namespace DuiLib
{
struct FriendListItemInfo
{
	bool folder;
	bool empty;
	CDuiString id;
	CDuiString logo;
	CDuiString nick_name;
	CDuiString description;
	CDuiString IPTStatus;
	CDuiString sign;
	bool mobile;
	CDuiString email;
    FriendListItemInfo()
    {
        folder = false;
        empty = false;
        mobile = false;
    }
};


class CFriendsUI : public CListUI
{
public:
	enum {SCROLL_TIMERID = 10};

	CFriendsUI(CPaintManagerUI& paint_manager);

	~CFriendsUI();

	bool Add(CControlUI* pControl);

	bool AddAt(CControlUI* pControl, int iIndex);

	bool Remove(CControlUI* pControl);

	bool RemoveAt(int iIndex);

	void RemoveAll();

	void DoEvent(TEventUI& event);

	Node* GetRoot();

	Node* AddChattingRoomNode(const FriendListItemInfo& item, int nCompareData=0, Node* parent = NULL);

	Node* FindNodeByCompareData(int nCpr);
	Node* GetNodeByIndex(int index);
	Node* GetChildNodeByStrId(Node* pNode,CDuiString strID);

	Node* AddNodeToFavoriteList(const FriendListItemInfo& item, int nCompareData=0, Node* parent = NULL);

	bool RemoveNode(Node* node);

	void SetChildVisible(Node* node, bool visible); 

	void SetNodeEditable(Node* node, bool bEdit);

	bool CanExpand(Node* node) const;

	/*bool SelectItem(int iIndex, bool bTakeFocus = false);

	bool SelectItems(int iIndex, bool bTakeFocus = false);
	bool SelectItemSingle(int iIndex, bool bTakeFocus = false);
	bool UnSelectItemSingle(int iIndex, bool bTakeFocus = false);*/
	list<Node*> GetSelectedItems();
	list<Node*> GetAllItems();
	void SetSelectItemSize(int nWidth, int nHeight);
	void SetNormalItemSize(int nWidth, int nHeight);
	void SetSelectViewModal(CControlUI* pControl, bool bSelect);
public:
	CPaintManagerUI& paint_manager_;
private:
	Node*	root_node_;
	LONG	delay_deltaY_;
	DWORD	delay_number_;
	DWORD	delay_left_;
	CDuiRect	text_padding_;
	int level_text_start_pos_;
	//CDuiString level_expand_image_;
	//CDuiString level_collapse_image_;

	int m_nItemNormalWidth;
	int m_nItemNormalHeight;
	int m_nItemSelectedWidth;
	int m_nItemSelectedHeight;

    CDialogBuilder m_dlgBuilder;
};

} // DuiLib
